#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int main()
{
    int T;
    vector<string> resenja;
    cin >> T;
    for(int i=0;i<T;i++) {
        int N,k1,k2;
        cin >> N;
        vector<int> A(N),B(N);
        for(int i=0;i<N;i++) {
            cin >> A[i];
            if(A[i]!=0) k1=i;
        }
        for(int i=0;i<N;i++) {
            cin >> B[i];
            if(B[i]!=0) k2=i;
        }
        if((k1-k2)%2!=0) resenja.push_back("DA");
        else resenja.push_back("NE");
    }
    for(int i=0;i<T;i++) {
        cout << resenja[i] << endl;
    }
    return 0;
}